from sqlalchemy import text

from pyat.schema import create_session
from pyat.schema.optmodel import Project, Projectauthor, Coauthor

session = create_session('OPT')


def getproject(projectid):
    project = session.query(Project).\
        filter(text("id=:projectid")).\
        params(projectid=projectid).\
        first()
    session.close()
    return project

# Get the global ids for the PI and coauthors of the project
def getauthors(projectid):
    pi = session.query(Projectauthor). \
        join(Project, Projectauthor.id == Project.pi). \
        filter(text("Project.id=:projectid")). \
        params(projectid=projectid)
    coauthors = session.query(Projectauthor). \
        join(Coauthor, Projectauthor.id == Coauthor.projectauthor_id) . \
        join(Project, Coauthor.project_id == Project.id). \
        filter(text("Project.id=:projectid")). \
        params(projectid=projectid)
    authors = pi.union(coauthors).all()
    session.close()
    return authors

def ispi(projectcode, globalid):
    pi = session.query(Projectauthor). \
        join(Project, Projectauthor.id == Project.pi). \
        filter(text("Project.projectcode=:projectcode")). \
        filter(text("Projectauthor.globalid=:globalid")). \
        params(projectcode=projectcode).\
        params(globalid=globalid).\
        one_or_none()
    if pi is None:
        return False
    else:
        return True



